/**
 * 2. Server pentru coada de mesaje
 * SO - Laborator 5 IPC
 */
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include <sys/stat.h>
#include <sys/types.h>
#include <mqueue.h>
#include <string.h>

#include "common.h"

int main(int argc, char **argv)
{
	mqd_t q;		/* descriptorul cozii de mesaje */
	struct mq_attr attr;
	char buf[MAX_SIZE + 1];
	int done = 0;

	/* TODO - initializare structura attr */
	attr.mq_flags = 0;
	attr.mq_maxmsg = 10;
	attr.mq_msgsize = MAX_SIZE;
	attr.mq_curmsgs = 0;

	/* TODO - creeaza coada */
	q = mq_open(QUEUE_NAME, O_CREAT | O_RDONLY, 0644, &attr);
	CHECK(q != (mqd_t) -1);

	do {
		ssize_t bytes_read;

		/* TODO - primeste mesaj */
		bytes_read = mq_receive(q, buf, MAX_SIZE, NULL);
		CHECK(bytes_read >= 0);

		buf[bytes_read] = 0;
		if (!strncmp(buf, MSG_END,3))
			done = 1;

		printf("Am primit: %s \n", buf);
	} while (!done);

	/* TODO - inchide si sterge coada */
	CHECK(mq_close(q) != (mqd_t) -1);
	CHECK(mq_unlink(QUEUE_NAME) != (mqd_t) -1);

	return 0;
}
